/*
 * DTAnime.java
 *
 * Created on 2001/12/13, 23:13
 * update: 2001/01/19
 * Last update 2003/01/05
 */

package hiformed.debug;

/**
 *
 * T. Arita
 * Ver. 0.1 
 */

//jdk 1.3.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Dimension;
import java.awt.BorderLayout;
import javax.swing.JSplitPane;

//hiform
import hiformed.grammar.*;


public class DTAnime implements ActionListener {
	
	private static JPanel panel = new JPanel();//S
	
	private static JPanel control_panel = new JPanel();
	private static Box control_box = new Box(BoxLayout.X_AXIS);//
	private static JButton start_button = new JButton("Start");
	private static JButton pause_button = new JButton("Pause");
	private static JButton stop_button = new JButton("Stop");
	
	//----------------------------------------------------------
	private static DTAnimePanel dt_anime_panel= new DTAnimePanel();
	private static JScrollPane jsp = new JScrollPane(dt_anime_panel);
	private static JPanel dt_outside_panel = new JPanel();
	
	
	//----------------------------------------------------------
	private static MGAnimePanel mg_anime_panel= new MGAnimePanel();
	private static JScrollPane mg_jsp = new JScrollPane(mg_anime_panel);
	private static JPanel mg_outside_panel = new JPanel();
	private MGNodeMarkSet node_mark_set;
	
	//----------------------------------------------------------
	private static JPanel center_panel = new JPanel();//
	private static JSplitPane sp;
	
	
	private static AnimeEngine engine= new AnimeEngine(mg_anime_panel, dt_anime_panel);
	
	/** Creates new DTAnime */
    public DTAnime() {
		init();
		addListeners();
    }
	
	
	private void initControlPanel(){
		control_panel.setBorder(new TitledBorder(new EtchedBorder(),"Animation Controler"));
		Border border = control_panel.getBorder();//
		Border margin = new EmptyBorder(0,0,0,0);//
		control_panel.setBorder(new CompoundBorder(border, margin));//
		
		control_box.add(start_button);
		control_box.add(control_box.createRigidArea(new Dimension(5,0)));
		control_box.add(pause_button);
		control_box.add(control_box.createRigidArea(new Dimension(5,0)));
		control_box.add(stop_button);
		
		control_panel.add(control_box);		
	}
	
	
	private void initDTPanel(){
		dt_outside_panel.setBorder(new TitledBorder(new EtchedBorder(),"Derivation Tree"));
		Border border = dt_outside_panel.getBorder();
		Border margin = new EmptyBorder(0,5,5,5);
		dt_outside_panel.setBorder(new CompoundBorder(border, margin));
		
		jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		dt_outside_panel.setLayout(new BorderLayout());
		dt_outside_panel.add("Center",jsp);
	}
	
	//new
	private void initMGPanel(){
		mg_outside_panel.setBorder(new TitledBorder(new EtchedBorder(),"Form Graph"));//2003/01/05 graph -> form graph
		Border border = mg_outside_panel.getBorder();
		Border margin = new EmptyBorder(0,5,5,5);
		mg_outside_panel.setBorder(new CompoundBorder(border, margin));
		
		mg_jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		mg_jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		mg_outside_panel.setLayout(new BorderLayout());
		mg_outside_panel.add("Center",mg_jsp);
	}
	
	//new
	/*
	private void initCenterPanel(){
		Box control_box = new Box(BoxLayout.X_AXIS);
		
		control_box.add(control_box.createHorizontalGlue());
		control_box.add(mg_outside_panel);
		control_box.add(dt_outside_panel);
		control_box.add(control_box.createHorizontalGlue());
		
		center_panel.setLayout(new BorderLayout());
		center_panel.add("Center", control_box);
	}
	*/
	
	//new 01/19
	private void initCenterPanel(){
		sp = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, mg_outside_panel, dt_outside_panel);		
		center_panel.setLayout(new BorderLayout());
		center_panel.add("Center", sp);
	}
	
	
	private void init(){
		initControlPanel();
		initMGPanel();//
		initDTPanel();
		initCenterPanel();
		
		panel.setLayout(new BorderLayout());
		panel.add("Center",center_panel);
		panel.add("South",control_panel);
		
		sp.setDividerLocation(340);//
	}
	
	
	private void addListeners(){
		start_button.addActionListener(this);
		pause_button.addActionListener(this);
		stop_button.addActionListener(this);
	}
	
	
	//----------------------------------------------------------------------
	// [ EVENT ]
	//----------------------------------------------------------------------
	//Cxg
	private boolean suspentFlag=false;
	public void actionPerformed(ActionEvent e){
		JButton button = (JButton)e.getSource();
		if(button == start_button){
			
			/*
			if(mg_anime_panel != null){
				mg_anime_panel.setNodeSet(node_mark_set);//////
			}
			*/
			
			engine.start();//Aj[VX^[g
		}else if(button == pause_button){
			if(suspentFlag==false){
				engine.suspend();//ꎞ~
				suspentFlag = true;
			}else{
				engine.resume();//ĊJ
				suspentFlag = false;
			}
		}else if(button == stop_button){
			engine.stop();// Aj[VSI
		}
	}
	
	public void setParameters( MarkedGraph mgraph, 
								PrecedenceTable pre_table, 
								ProductionManager pro_manager, 
								MGNodeMarkSet node_mark_set){
		
		engine.setMarkedGraph(mgraph);
		engine.setPrecedenceTable(pre_table);
		engine.setProductions(pro_manager);
		engine.setMarks(node_mark_set);
		
		//this.node_mark_set = node_mark_set;///
		mg_anime_panel.setNodeSet(node_mark_set);//////
		mg_anime_panel.setMarkedGraph(mgraph);//////
	}
	
	//Ajppln
	public JPanel getAnimePanel(){
		return panel;
	}
}
