/*
 * DTAnimePanel.java
 *
 * Created on 2001/12/13, 23:29
 */

package hiformed.debug;

/**
 *
 * Tomokazu ARITA
 * Ver 0.1
 */

import javax.swing.*;
import java.awt.*;
import java.util.Vector;
import java.awt.image.*;
//import java.awt.event.*;
//import java.awt.geom.*;

//hiform
import hiformed.grammar.*;
import hiformed.editor.derivationtree.*;

public class DTAnimePanel extends JPanel {
	
	//Panel Size
	static private int size_x = 1500;//3000
	static private int size_y = 1500;//3000
	
	//Graphics
	private BufferedImage buf;
	private Graphics2D bufg2d;
	
	
	//Stroke
	//nomal_stroke
	private BasicStroke bs = new BasicStroke(1.0f);
	
	//hasen
	private float[] f = {5.0f,5.0f};
	private BasicStroke dash_bs = new BasicStroke(1.0f,
										BasicStroke.CAP_BUTT,
										BasicStroke.JOIN_MITER,
										10.0f,
										f,
										0.0f);

	//
	//DTBlock derivation_tree = null;
	Vector derivation_trees;
	
	
	
	/** Creates new DTAnimePanel */
    public DTAnimePanel() {
	}
	
	
	//------------------------------------
	
	/*
	//Compornents
	static JFrame MainFrame;
	static JPanel MainPanel;
	static JScrollPane jsp;
	static DTreePane viewer;
	*/

	
	private void setDTBlockLayoutData(DTBlock block, DTLayoutDataCarryer carryer){
		block.setBlockX(carryer.block_x);
		block.setBlockY(carryer.block_y);
		
		carryer.node_x = carryer.block_x+BlockLayoutData.left_margin;
		carryer.node_y = carryer.block_y+BlockLayoutData.top_margin;
		setDTNodeLayoutData(block.getStartNode(), carryer );
		
		carryer.block_width  += BlockLayoutData.left_margin + BlockLayoutData.right_margin;
		carryer.block_height += BlockLayoutData.top_margin + BlockLayoutData.bottom_margin;
		carryer.subtree_y = carryer.block_y + carryer.block_height + BlockLayoutData.v_margin;
		setDTSubTreeLayoutData(block.getStartNode(), carryer);
		
	}
	
	
	
	private void setDTNodeLayoutData(DTNode node, DTLayoutDataCarryer carryer){
	
		node.setNodeX(carryer.node_x);
		node.setNodeY(carryer.node_y);
		
		
		DTNode next_node;
		if((next_node = node.getNextNode()) != null){
			carryer.node_x += NodeData.cell_width+NodeData.between_cells;
			setDTNodeLayoutData(next_node, carryer);
			carryer.block_width += NodeData.cell_width+NodeData.between_cells;
		}else{
			carryer.block_width += NodeData.cell_width;
		}
		carryer.block_height = NodeData.cell_height*4;
		
	}
	
	
	
	private void setDTSubTreeLayoutData(DTNode node, DTLayoutDataCarryer carryer){
			
		DTBlock next_block;
		DTLayoutDataCarryer subtree_carryer = new DTLayoutDataCarryer();
		if((next_block = node.getNextBlock()) != null){
			subtree_carryer.block_x = carryer.subtree_x;
			subtree_carryer.block_y = carryer.subtree_y;
			subtree_carryer.subtree_x = carryer.subtree_x;
			
			setDTBlockLayoutData(next_block, subtree_carryer);
			carryer.subtree_width = subtree_carryer.block_width;//
			
			int block_right   = subtree_carryer.block_width + subtree_carryer.block_x + BlockLayoutData.h_margin;
			int subtree_right = subtree_carryer.subtree_x;
			if(subtree_right > block_right){
				carryer.subtree_x = subtree_right;
			}else{
				carryer.subtree_x = block_right;
			}	
		}
		
		
		DTNode next_node;
		if((next_node = node.getNextNode()) != null){
			setDTSubTreeLayoutData(next_node, carryer);
		}
		
	}
	
	
	
	private void drawDTBlock(DTBlock block){
		
		DTNode node = block.getStartNode();
		Rectangle r = drawDTNode(node);
		
		bufg2d.setStroke(dash_bs);//stroke
		bufg2d.setColor(Color.blue);//color
		bufg2d.drawRect(
			block.getBlockX(),
			block.getBlockY(), 
			r.width+BlockLayoutData.left_margin+BlockLayoutData.right_margin,
			r.height+BlockLayoutData.top_margin+BlockLayoutData.bottom_margin
		);
	}
	
	
	private Rectangle drawDTNode(DTNode node){
		bufg2d.setStroke(bs);//stroke
		bufg2d.setColor(Color.black);//color
		
		int x = node.getNodeX();
		int y = node.getNodeY();
		bufg2d.drawRect(x, y, NodeData.cell_width, NodeData.cell_height);
		bufg2d.drawRect(NodeData.cell_width+x-NodeData.next_cell_width, y, 
						NodeData.next_cell_width, NodeData.cell_height);
		bufg2d.drawRect(x, y+NodeData.cell_height, 
						NodeData.cell_width, NodeData.cell_height);
		
		
		bufg2d.drawRect(x, y+NodeData.cell_height*2, 
						NodeData.attribute_cell_width, NodeData.cell_height);
		bufg2d.drawRect(x+NodeData.attribute_cell_width, y+NodeData.cell_height*2, 
						NodeData.attribute_cell_width, NodeData.cell_height);
		bufg2d.drawRect(x+NodeData.attribute_cell_width*2, y+NodeData.cell_height*2, 
						NodeData.attribute_cell_width, NodeData.cell_height);
		bufg2d.drawRect(x+NodeData.attribute_cell_width*3, y+NodeData.cell_height*2, 
						NodeData.attribute_cell_width, NodeData.cell_height);
		
		bufg2d.drawRect(x, y+NodeData.cell_height*3, 
						NodeData.cell_width, NodeData.cell_height);
		bufg2d.drawRect(NodeData.cell_width+x-NodeData.next_block_width, 
						y+NodeData.cell_height*3,
						NodeData.next_block_width, NodeData.cell_height);
		
		
		
		
		bufg2d.setColor(Color.gray);//color
		bufg2d.setFont(new Font("Helvetica",Font.BOLD,9));//font
		
		String node_id = Integer.toString(node.getNodeID());
		
		String att_x = Integer.toString(node.getAttX());
		String att_y = Integer.toString(node.getAttY());
		String att_width  = Integer.toString(node.getAttWidth());
		String att_height = Integer.toString(node.getAttHeight());
		
		// -1̒l\Ȃ
		if(node.getAttX() == -1){ att_x = ""; }
		if(node.getAttY() == -1){ att_y = ""; }
		if(node.getAttWidth() == -1){  att_width  = ""; }
		if(node.getAttHeight() == -1){ att_height = ""; }
		
		bufg2d.drawString(node_id, x+NodeData.string_start_point_x, 
							y+NodeData.string_start_point_y);
		bufg2d.drawString(node.getNodeLabel(), x+NodeData.string_start_point_x,
							y+NodeData.cell_height+NodeData.string_start_point_y);
		bufg2d.drawString(att_x, x+NodeData.string_start_point_x,
							y+NodeData.cell_height*2+NodeData.string_start_point_y);
		bufg2d.drawString(att_y, 
							x+NodeData.attribute_cell_width+NodeData.string_start_point_x,
							y+NodeData.cell_height*2+NodeData.string_start_point_y);
		bufg2d.drawString(att_width,
							x+NodeData.attribute_cell_width*2+NodeData.string_start_point_x,
							y+NodeData.cell_height*2+NodeData.string_start_point_y);
		bufg2d.drawString(att_height,
							x+NodeData.attribute_cell_width*3+NodeData.string_start_point_x,
							y+NodeData.cell_height*2+NodeData.string_start_point_y);
		
		/////[production] Note!... null exception
		Production production = node.getProduction();
		if(production != null){
			bufg2d.drawString(
				production.getProductionName(),
				x+NodeData.string_start_point_x,
				y+NodeData.cell_height*3+NodeData.string_start_point_y
			);
		}
		
		Rectangle r;
		DTNode next_node;
		int flag = 0;
		if( ( next_node = node.getNextNode()) != null ){
			r = drawDTNode( next_node );
			flag = 1;
		}else{
			r = new Rectangle(x,y,0,0);
		}
		
		DTBlock next_block;
		if( (next_block = node.getNextBlock()) != null ){
			drawDTBlock(next_block);
			
			//Edge for Next Block
			bufg2d.setStroke(bs);
			bufg2d.setColor(Color.gray);//color
			bufg2d.drawLine(
				x+NodeData.next_block_point_x,
				y+NodeData.next_block_point_y,
				next_block.getBlockX()+20,
				next_block.getBlockY()
			);
		}
		
		int block_x = x;
		int block_y = y;
		int block_width  = NodeData.cell_width+NodeData.between_cells*flag+r.width;
		int block_height = NodeData.cell_height*4;
		
		return new Rectangle(block_x,block_y,block_width,block_height);
	}
	
	
	
	
	public Dimension getPreferredSize(){
		return new Dimension(size_x+10, size_y+10);
	}
	
	public Dimension getMinimumSize(){
		return getPreferredSize();
	}
	
	
	//Paint main
	int initFlag = 0;
	public void paint(Graphics g){
		Graphics2D g2 = (Graphics2D)g;
		if(initFlag == 0){
			initPane();
			if(derivation_trees != null){ drawPanel(); }
			initFlag++;
		}
		
		g2.drawImage(buf,0,0,this);
	}
	
	public void update(Graphics g){
		paint(g);
	}
		
	
	
	//KVȂƂĂяo.
	public void setDTrees(Vector dtrees){
		this.derivation_trees = dtrees;
		initFlag = 0;
		repaint();//
	}
	
	
	public void drawPanel(){		
		//
		DTLayoutDataCarryer carryer = new DTLayoutDataCarryer();
		carryer.block_x = 10; carryer.block_y = 10;
		carryer.subtree_x = carryer.block_x;
		for(int i=0; i<derivation_trees.size(); i++){
			DTBlock derivation_tree = (DTBlock)derivation_trees.elementAt(i);
			setDTBlockLayoutData(derivation_tree, carryer);
			
			carryer.subtree_x += 10;////
			carryer.block_x = carryer.subtree_x;////
		}
		//
		
		for(int i=0; i<derivation_trees.size(); i++){
			DTBlock derivation_tree = (DTBlock)derivation_trees.elementAt(i);
			drawDTBlock(derivation_tree);
		}
	}
	
	
	
	//pl̏
	//\OtBbNXA`GCAXݒɂD
	private void initPane(){
				
		Dimension dim = getSize();
		
		buf = (BufferedImage)createImage(dim.width, dim.height);
		bufg2d = (Graphics2D)buf.getGraphics();
		
		bufg2d.setColor(Color.white);
		bufg2d.fillRect(0, 0, dim.width, dim.height);
		
		/*
		RenderingHints qualityHints = 
				new RenderingHints(RenderingHints.KEY_ANTIALIASING,
					RenderingHints.VALUE_ANTIALIAS_ON);

		qualityHints.put(RenderingHints.KEY_RENDERING,
						RenderingHints.VALUE_RENDER_QUALITY);

		bufg2d.setRenderingHints(qualityHints);
		*/
	}
	
	
	
	//pl̃NA
	//initPaneƓC_uobt@쐬Ă
	//Ƃ
	//Aj[V̂߂ɁCinitPanePE
	private void clearPanel(){
		Dimension dim = getSize();
		
		bufg2d.setColor(Color.white);
		bufg2d.fillRect(0, 0, dim.width, dim.height);
	}

	
}
