/* 
	DTreePane.java

	Title:			GMLViewer
	Author:			Tomokazu ARITA
	update:			2001/11/27
*/

package hiformed.editor.derivationtree;

//jdk 1.3.x
import java.awt.Font;
import java.awt.Color;
import java.awt.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javax.swing.table.*;
import java.awt.geom.CubicCurve2D.Double;
import java.awt.geom.*;

//hiformed
//import hiformed.TestGG.*;//
import hiformed.grammar.*;


public class DTreePane extends JPanel{
	
	//GML parameter
	static private String version = "0.01b";
	
	//Panel Size
	static private int size_x = 3000;
	static private int size_y = 3000;
	
	//Frame Size
	static private int frame_size_x = 500;
	static private int frame_size_y = 400;
	
	
	//Graphics
	private BufferedImage buf;
	private Graphics2D bufg2d;
	
	//Stroke
	//nomal_stroke
	private BasicStroke bs = new BasicStroke(1.0f);
	
	//hasen
	private float[] f = {5.0f,5.0f};
	private BasicStroke dash_bs = new BasicStroke(1.0f,
										BasicStroke.CAP_BUTT,
										BasicStroke.JOIN_MITER,
										10.0f,
										f,
										0.0f);
	
	
	//Compornents
	static JFrame MainFrame;
	static JPanel MainPanel;
	static JScrollPane jsp;
	static DTreePane viewer;
	
	//
	DTBlock derivation_tree = null;
	
	public DTreePane(){
	}

	// Main entry point
	static public void main(String[] args){
		viewer = new DTreePane();
		
		initCompornent();
		
		WindowListener l = new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				MainFrame.dispose();
				System.exit(0);
			}
		};
		
		MainFrame.getContentPane().add(MainPanel);
		MainFrame.addWindowListener(l);
		MainFrame.setSize(frame_size_x, frame_size_y);
		MainFrame.show();
		
	}
	
	static private void initCompornent(){
		
		MainFrame = new JFrame("GMLViewer "+version);
		MainPanel = new JPanel();
		
		jsp = new JScrollPane(viewer);
		jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);		
		
		MainPanel.setLayout(new BorderLayout());
		MainPanel.add(jsp);
	}
	
	/*
	private void drawPanel1(){
		Dimension dim = getSize();
		
		buf = (BufferedImage)createImage(dim.width, dim.height);
		bufg2d = (Graphics2D)buf.getGraphics();
		
		bufg2d.setColor(Color.white);
		bufg2d.fillRect(0, 0, dim.width, dim.height);
		
				
		
		RenderingHints qualityHints = 
				new RenderingHints(RenderingHints.KEY_ANTIALIASING,
					RenderingHints.VALUE_ANTIALIAS_ON);

		qualityHints.put(RenderingHints.KEY_RENDERING,
						RenderingHints.VALUE_RENDER_QUALITY);

		bufg2d.setRenderingHints(qualityHints);
		
		//
		//block1
		DTNode node1 = new DTNode();
		node1.setNodeID(1);
		node1.setNodeLabel("[Head-root]");
		//node1.setProduction("H1");
		
		DTNode node2 = new DTNode();
		node2.setNodeID(2);
		node2.setNodeLabel("[Head-scalar]");
		//node2.setProduction("H2");
		
		node1.setNextNode(node2);
		
		DTBlock block1 = new DTBlock(node1);
		
		//block2
		DTNode node3 = new DTNode();
		node3.setNodeID(3);
		node3.setNodeLabel("[Head-root]");
		//node3.setProduction("H3");
		DTBlock block2 = new DTBlock(node3);
		node1.setNextBlock(block2);
		
		
		//block3
		DTNode node4 = new DTNode();
		node4.setNodeID(4);
		node4.setNodeLabel("[Head-root]");
		//node4.setProduction("H4");
		
		DTNode node5 = new DTNode();
		node5.setNodeID(5);
		node5.setNodeLabel("[Head-root]");
		//node5.setProduction("H5");
		
		DTNode node6 = new DTNode();
		node6.setNodeID(6);
		node6.setNodeLabel("[Head-root]");
		//node6.setProduction("H6");
		
		node4.setNextNode(node5);
		node5.setNextNode(node6);
		DTBlock block3 = new DTBlock(node4);
		node3.setNextBlock(block3);
		
		
		//block4
		DTNode node7 = new DTNode();
		node7.setNodeID(7);
		node7.setNodeLabel("[Head-root]");
		//node7.setProduction("H7");
		DTBlock block4 = new DTBlock(node7);
		node2.setNextBlock(block4);

		
		//
		DTLayoutDataCarryer carryer = new DTLayoutDataCarryer();
		carryer.block_x = 10; carryer.block_y = 10;
		carryer.subtree_x = carryer.block_x;
		setDTBlockLayoutData(block1, carryer);
		//
		drawDTBlock(block1);
	}
	*/
	
	private void setDTBlockLayoutData(DTBlock block, DTLayoutDataCarryer carryer){
		block.setBlockX(carryer.block_x);
		block.setBlockY(carryer.block_y);
		
		carryer.node_x = carryer.block_x+BlockLayoutData.left_margin;
		carryer.node_y = carryer.block_y+BlockLayoutData.top_margin;
		setDTNodeLayoutData(block.getStartNode(), carryer );
		
		carryer.block_width  += BlockLayoutData.left_margin + BlockLayoutData.right_margin;
		carryer.block_height += BlockLayoutData.top_margin + BlockLayoutData.bottom_margin;
		carryer.subtree_y = carryer.block_y + carryer.block_height + BlockLayoutData.v_margin;
		setDTSubTreeLayoutData(block.getStartNode(), carryer);
		
		
	}
	
	
	private void setDTNodeLayoutData(DTNode node, DTLayoutDataCarryer carryer){
	
		node.setNodeX(carryer.node_x);
		node.setNodeY(carryer.node_y);
		
		
		DTNode next_node;
		if((next_node = node.getNextNode()) != null){
			carryer.node_x += NodeData.cell_width+NodeData.between_cells;
			setDTNodeLayoutData(next_node, carryer);
			carryer.block_width += NodeData.cell_width+NodeData.between_cells;
		}else{
			carryer.block_width += NodeData.cell_width;
		}
		carryer.block_height = NodeData.cell_height*4;
		
	}
	
	
	private void setDTSubTreeLayoutData(DTNode node, DTLayoutDataCarryer carryer){
		
		
		DTBlock next_block;
		DTLayoutDataCarryer subtree_carryer = new DTLayoutDataCarryer();
		if((next_block = node.getNextBlock()) != null){
			subtree_carryer.block_x = carryer.subtree_x;
			subtree_carryer.block_y = carryer.subtree_y;
			subtree_carryer.subtree_x = carryer.subtree_x;
			
			setDTBlockLayoutData(next_block, subtree_carryer);
			carryer.subtree_width = subtree_carryer.block_width;//
			
			int block_right   = subtree_carryer.block_width + subtree_carryer.block_x + BlockLayoutData.h_margin;
			int subtree_right = subtree_carryer.subtree_x;
			if(subtree_right > block_right){
				carryer.subtree_x = subtree_right;
			}else{
				carryer.subtree_x = block_right;
			}
			
			
		}
		
		
		DTNode next_node;
		if((next_node = node.getNextNode()) != null){
			setDTSubTreeLayoutData(next_node, carryer);
		}
		
	}
	
	
	
	private void drawDTBlock(DTBlock block){
		
		DTNode node = block.getStartNode();
		Rectangle r = drawDTNode(node);
		
		bufg2d.setStroke(dash_bs);//stroke
		bufg2d.setColor(Color.blue);//color
		bufg2d.drawRect(
			block.getBlockX(),
			block.getBlockY(), 
			r.width+BlockLayoutData.left_margin+BlockLayoutData.right_margin,
			r.height+BlockLayoutData.top_margin+BlockLayoutData.bottom_margin
		);
	}
	
	private Rectangle drawDTNode(DTNode node){
		bufg2d.setStroke(bs);//stroke
		bufg2d.setColor(Color.black);//color
		
		int x = node.getNodeX();
		int y = node.getNodeY();
		bufg2d.drawRect(x, y, NodeData.cell_width, NodeData.cell_height);
		bufg2d.drawRect(NodeData.cell_width+x-NodeData.next_cell_width, y, 
						NodeData.next_cell_width, NodeData.cell_height);
		bufg2d.drawRect(x, y+NodeData.cell_height, 
						NodeData.cell_width, NodeData.cell_height);
		
		
		bufg2d.drawRect(x, y+NodeData.cell_height*2, 
						NodeData.attribute_cell_width, NodeData.cell_height);
		bufg2d.drawRect(x+NodeData.attribute_cell_width, y+NodeData.cell_height*2, 
						NodeData.attribute_cell_width, NodeData.cell_height);
		bufg2d.drawRect(x+NodeData.attribute_cell_width*2, y+NodeData.cell_height*2, 
						NodeData.attribute_cell_width, NodeData.cell_height);
		bufg2d.drawRect(x+NodeData.attribute_cell_width*3, y+NodeData.cell_height*2, 
						NodeData.attribute_cell_width, NodeData.cell_height);
		
		bufg2d.drawRect(x, y+NodeData.cell_height*3, 
						NodeData.cell_width, NodeData.cell_height);
		bufg2d.drawRect(NodeData.cell_width+x-NodeData.next_block_width, 
						y+NodeData.cell_height*3,
						NodeData.next_block_width, NodeData.cell_height);
		
		
		
		
		bufg2d.setColor(Color.gray);//color
		bufg2d.setFont(new Font("Helvetica",Font.BOLD,9));//font
		
		String node_id = Integer.toString(node.getNodeID());
		
		String att_x = Integer.toString(node.getAttX());
		String att_y = Integer.toString(node.getAttY());
		String att_width  = Integer.toString(node.getAttWidth());
		String att_height = Integer.toString(node.getAttHeight());
		
		// -1̒l\Ȃ
		if(node.getAttX() == -1){ att_x = ""; }
		if(node.getAttY() == -1){ att_y = ""; }
		if(node.getAttWidth() == -1){  att_width  = ""; }
		if(node.getAttHeight() == -1){ att_height = ""; }
		
		bufg2d.drawString(node_id, x+NodeData.string_start_point_x, 
							y+NodeData.string_start_point_y);
		bufg2d.drawString(node.getNodeLabel(), x+NodeData.string_start_point_x,
							y+NodeData.cell_height+NodeData.string_start_point_y);
		bufg2d.drawString(att_x, x+NodeData.string_start_point_x,
							y+NodeData.cell_height*2+NodeData.string_start_point_y);
		bufg2d.drawString(att_y, 
							x+NodeData.attribute_cell_width+NodeData.string_start_point_x,
							y+NodeData.cell_height*2+NodeData.string_start_point_y);
		bufg2d.drawString(att_width,
							x+NodeData.attribute_cell_width*2+NodeData.string_start_point_x,
							y+NodeData.cell_height*2+NodeData.string_start_point_y);
		bufg2d.drawString(att_height,
							x+NodeData.attribute_cell_width*3+NodeData.string_start_point_x,
							y+NodeData.cell_height*2+NodeData.string_start_point_y);
		
		/////[production] Note!... null exception
		Production production = node.getProduction();
		if(production != null){
			bufg2d.drawString(
				production.getProductionName(),
				x+NodeData.string_start_point_x,
				y+NodeData.cell_height*3+NodeData.string_start_point_y
			);
		}
		
		Rectangle r;
		DTNode next_node;
		int flag = 0;
		if( ( next_node = node.getNextNode()) != null ){
			r = drawDTNode( next_node );
			flag = 1;
		}else{
			r = new Rectangle(x,y,0,0);
		}
		
		DTBlock next_block;
		if( (next_block = node.getNextBlock()) != null ){
			drawDTBlock(next_block);
			
			//Edge for Next Block
			bufg2d.setStroke(bs);
			bufg2d.setColor(Color.gray);//color
			bufg2d.drawLine(
				x+NodeData.next_block_point_x,
				y+NodeData.next_block_point_y,
				next_block.getBlockX()+20,
				next_block.getBlockY()
			);
		}
		
		int block_x = x;
		int block_y = y;
		int block_width  = NodeData.cell_width+NodeData.between_cells*flag+r.width;
		int block_height = NodeData.cell_height*4;
		
		return new Rectangle(block_x,block_y,block_width,block_height);
	}
	
	
	public Dimension getPreferredSize(){
		return new Dimension(size_x+10, size_y+10);
	}
	
	public Dimension getMinimumSize(){
		return getPreferredSize();
	}

	int Flag = 0;
	public void paint(Graphics g){
		Graphics2D g2 = (Graphics2D)g;
		if(Flag == 0){
			initPane();
			if(derivation_tree != null){ drawPanel(); }
			Flag++;
		}
		
		g2.drawImage(buf,0,0,this);
	}
	
	public void update(Graphics g){
		paint(g);
	}
	
	/*
	//test--------------------------------------------------
	private MarkedGraph makeGraph(){
		
		MGNode node1 = new MGNode();
		MGNode node2 = new MGNode();
		MGNode node3 = new MGNode();
		MGNode node4 = new MGNode();
		
		node1.setNodeLabel(TestNodeSet.T__GROUP);
		node2.setNodeLabel(TestNodeSet.T__CELL);
		node3.setNodeLabel(TestNodeSet.T__CELL);
		node4.setNodeLabel(TestNodeSet.T__CELL);
		
		node1.setInEndNode(node2);
		node2.setInStartNode(node1);
		
		node2.setLfStartNode(node3);
		node3.setLfEndNode(node2);
		
		node2.setOvStartNode(node4);
		node4.setOvEndNode(node2);
		
		//x, y, width & height
		node1.setAttX(0); node1.setAttY(0);
		node2.setAttWidth(50);  node2.setAttHeight(20);
		node3.setAttWidth(50);  node3.setAttHeight(20);
		node4.setAttWidth(100); node4.setAttHeight(30);
		
		MarkedGraph graph = new MarkedGraph();
		graph.setStartNode(node1);
		return graph;
		
	}
	*/
	
	/*
	public void drawPanel2(){
		
		Dimension dim = getSize();
		
		buf = (BufferedImage)createImage(dim.width, dim.height);
		bufg2d = (Graphics2D)buf.getGraphics();
		
		bufg2d.setColor(Color.white);
		bufg2d.fillRect(0, 0, dim.width, dim.height);
		
				
		
		RenderingHints qualityHints = 
				new RenderingHints(RenderingHints.KEY_ANTIALIASING,
					RenderingHints.VALUE_ANTIALIAS_ON);

		qualityHints.put(RenderingHints.KEY_RENDERING,
						RenderingHints.VALUE_RENDER_QUALITY);

		bufg2d.setRenderingHints(qualityHints);
		
		
		MarkedGraph graph = makeGraph();
		DTMaker dt_maker = new DTMaker(new TPSet(), new TestPTable(), new TestNodeSet());//
		dt_maker.makeDT(graph);//
		graph = dt_maker.getTestMG();//
		DTBlock dtree = dt_maker.getDTree();
		
		//
		DTLayoutDataCarryer carryer = new DTLayoutDataCarryer();
		carryer.block_x = 10; carryer.block_y = 10;
		carryer.subtree_x = carryer.block_x;
		setDTBlockLayoutData(dtree, carryer);
		//
		drawDTBlock(dtree);
		
	}
	*/
	
	//test--------------------------------------------------
	
	
	//KVȂƂĂяo.
	public void setDTree(DTBlock dtree){
		this.derivation_tree = dtree;
		Flag = 0;
		repaint();//
	}
	
	public void drawPanel(){
		
		/*
		Dimension dim = getSize();
		
		buf = (BufferedImage)createImage(dim.width, dim.height);
		bufg2d = (Graphics2D)buf.getGraphics();
		
		bufg2d.setColor(Color.white);
		bufg2d.fillRect(0, 0, dim.width, dim.height);
		
				
		
		RenderingHints qualityHints = 
				new RenderingHints(RenderingHints.KEY_ANTIALIASING,
					RenderingHints.VALUE_ANTIALIAS_ON);

		qualityHints.put(RenderingHints.KEY_RENDERING,
						RenderingHints.VALUE_RENDER_QUALITY);

		bufg2d.setRenderingHints(qualityHints);
		*/
		
		
		//
		DTLayoutDataCarryer carryer = new DTLayoutDataCarryer();
		carryer.block_x = 10; carryer.block_y = 10;
		carryer.subtree_x = carryer.block_x;
		setDTBlockLayoutData(derivation_tree, carryer);
		//
		drawDTBlock(derivation_tree);
	}
	
	private void initPane(){
				
		Dimension dim = getSize();
		
		buf = (BufferedImage)createImage(dim.width, dim.height);
		bufg2d = (Graphics2D)buf.getGraphics();
		
		bufg2d.setColor(Color.white);
		bufg2d.fillRect(0, 0, dim.width, dim.height);
		
				
		/*
		RenderingHints qualityHints = 
				new RenderingHints(RenderingHints.KEY_ANTIALIASING,
					RenderingHints.VALUE_ANTIALIAS_ON);

		qualityHints.put(RenderingHints.KEY_RENDERING,
						RenderingHints.VALUE_RENDER_QUALITY);

		bufg2d.setRenderingHints(qualityHints);
		*/
	}

}
