/* 
	StartWindow.java

	Author:			Tomokazu ARITA
	update:			2001/11/28
*/

package hiformed.editor.dialog;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
//import java.lang.Thread;
import java.io.File;
import java.net.URL;//

public class FileSelectDialog extends JDialog implements ItemListener{
	
	JPanel center_back  = new JPanel();
	JPanel center_front = new JPanel();
	JScrollPane jsp;
	JPanel south_back  = new JPanel();
	
	
	JButton ok_button     = new JButton("OK");
	JButton cancel_button = new JButton("Cancel");
	
	JPanel main_panel = new JPanel(); 
	private Box box = new Box(BoxLayout.Y_AXIS);
	
	static String   TITLE = "Select A Form";
	String[] Forms = {
		"A1"
	};
	
	private ButtonGroup bgroup = new ButtonGroup();
	private ImageIcon ic1;
	private ImageIcon ic2;
	private JRadioButton a1;
	
	private String form_name = "";
	
	//event
	WindowListener l;
	
	public FileSelectDialog(JFrame owner,String title){
		super(owner,title,true);
		initDialog();
	}
	
	private void initDialog(){
		center_back.setBorder(new TitledBorder(new EtchedBorder(),TITLE));
		Border border = center_back.getBorder();
		Border margin = new EmptyBorder(0,5,5,5);
		center_back.setBorder(new CompoundBorder(border, margin));
		
		initMainPanel();
		jsp = new JScrollPane(main_panel);
		jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		center_back.setLayout(new BorderLayout());
		center_back.add("Center",jsp);
		
		
		ActionListener ok_event = new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if(form_name.equals("") != true){
					dispose();
				}
			}
		};
		ok_button.addActionListener(ok_event);
		
		ActionListener cancel_event = new ActionListener(){
			public void actionPerformed(ActionEvent e){
				form_name = "";//
				dispose();
			}
		};
		cancel_button.addActionListener(cancel_event);
		
		
		south_back.setLayout(new FlowLayout());
		south_back.add(ok_button);
		south_back.add(cancel_button);
		
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add("Center",center_back);
		getContentPane().add("South",south_back);
		
		l = new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				//hide();
				dispose();
			}
		};
	}
	
	
	private void initMainPanel(){
		String sep = File.separator;
		//ic1 = new ImageIcon("hiformed"+sep+"edior"+sep+"dialog"+sep+"image"+sep+"file_icon.gif");
		//ic2 = new ImageIcon("hiformed"+sep+"edior"+sep+"dialog"+sep+"image"+sep+"file_icon_select.gif");
		
		URL url_image1 = this.getClass().getResource("file_icon.gif");
		URL url_image2 = this.getClass().getResource("file_icon_select.gif");
		ic1 = new ImageIcon(Toolkit.getDefaultToolkit().getImage(url_image1));
		ic2 = new ImageIcon(Toolkit.getDefaultToolkit().getImage(url_image2));
		
		
		a1 = new JRadioButton(Forms[0],ic1);
		box.add(a1);
		bgroup.add(a1);
		a1.addItemListener(this);
		
		main_panel.add(box);
	}
	
	
	public String getFormName(){
		return form_name;
	}
	
	//event
	public void itemStateChanged(ItemEvent e){
		if(e.getStateChange() == e.SELECTED){
			JRadioButton button = (JRadioButton)e.getItem();
			form_name = button.getText();
			button.setIcon(ic2);
		}
		
		if(e.getStateChange() == e.DESELECTED){
			JRadioButton button = (JRadioButton)e.getItem();
			button.setIcon(ic1);
		}
	}
	
}