/* 
	BlockManeger.java

	Author:			Tomokazu ARITA
	update:			2001/11/27
        Last update: 2003/01/05
*/

package hiformed.editor.mgpanel;

import java.lang.*;
import java.awt.*;
//import java.awt.geom.*;

public class BlockManeger{
	
	PointerToBlockOfStartingLayer BlockList = null;
	Block StartBlock;
	
	static final int X = 1;
	static final int Y = 1;
	
	private static final int MAX = 100; 
	public static int BLOCKWIDTH[]  = new int[MAX];
	public static int BLOCKHEIGHT[] = new int[MAX];
        
        //add 2003/01/05
        private int MAX_X=0; //x̍ől
        private int MAX_Y=0; //y̍ől
        //add 2003/01/05

        
	public BlockManeger(Block block){
		initBlockList(block);
	}
	
		
	private void setLayerSize(Block block){
		
		Block start_block  = block;
		Block row_block    = start_block;
		Block column_block = row_block;
		
		int WIDTH  = 0;
		int HEIGHT = 0;
		
		int ROW_WIDTH  = 0;
		int ROW_HEIGHT = 0;
		
		
		while(row_block != null){
			ROW_WIDTH  = column_block.getArWidth();
			ROW_HEIGHT = column_block.getArHeight();
			System.out.println("?TITLE:"+column_block.getTitle()+",W"+(ROW_WIDTH)+",H"+(ROW_HEIGHT));//
			while( (column_block = column_block.getNeighborBlock(Block.LF,Block.START)) != null ){
				ROW_WIDTH  += column_block.getArWidth();
				ROW_HEIGHT =  Math.max(column_block.getArHeight(),ROW_HEIGHT);
			}
			WIDTH  =  Math.max(WIDTH,ROW_WIDTH);
			HEIGHT += ROW_HEIGHT; 
			row_block = row_block.getNeighborBlock(Block.OV,Block.START);
			column_block = row_block;
		}
		
		System.out.println("?1");//
		if((start_block = start_block.getNeighborBlock(Block.IN,Block.START))!= null){
			start_block.setArSize(WIDTH+1, HEIGHT+1);
			System.out.println("TITLE:"+start_block.getTitle()+",W"+(WIDTH+1)+",H"+(HEIGHT+1));//
		}
	}
	
	
	public Block getStartBlock(Block start_block){
		Block block = start_block;
		Block next = null;
		
		while(true){
			if( (next = block.getNeighborBlock(Block.LF, Block.END)) != null){
				block = next;
			}else if((next = block.getNeighborBlock(Block.OV, Block.END)) != null){
				block = next;
			}else if((next = block.getNeighborBlock(Block.IN, Block.START)) != null){
				block = next;
			}else{
				break;
			}
		}
		
		return block;
	}
	
	
	//ubN̐ڑiOtoオĂjĂяoB
	//傫vZOɌĂяoȂƂȂB
	public void initBlockList(Block block){
		Block start_block = getStartBlock(block);
		StartBlock = start_block;
		setLayerNumber(StartBlock,1);
	}
	
	
	
	
	//Kw(Layer)ݒ肷B
	//setLayerNumber(StartBlock,1);//gp@
	//
	private void setLayerNumber(Block start_block, int layer_number){
	
		Block row_block    = start_block;
		Block column_block = row_block; 
		Block downblock;
		
		
		addBlockList(new PointerToBlockOfStartingLayer(start_block),layer_number);
		
		row_block.setArLayer(layer_number);
		while(row_block != null){
			if(column_block != null){
				column_block.setArLayer(layer_number);
				if((downblock = column_block.getNeighborBlock(Block.IN,Block.END)) != null){
					setLayerNumber(downblock,layer_number+1);
				}
				column_block = column_block.getNeighborBlock(Block.LF,Block.START);
			}else if((row_block = row_block.getNeighborBlock(Block.OV,Block.START)) != null){
				column_block = row_block;
			}
		}
		
		
	}
	
	private void addBlockList(PointerToBlockOfStartingLayer pointer, int layer_number){
		
		PointerToBlockOfStartingLayer p1;
		PointerToBlockOfStartingLayer p2;
		
		if(layer_number == 1){
			BlockList = pointer;
			return;
		}else{
			p1 = BlockList;
			p2 = p1.nextLayer();
			for(int i = 2; i<layer_number; i++){
				p1 = p1.nextLayer();
				p2 = p1.nextLayer();
			}
			if(p2 == null){
				pointer.setBeforePointerOfLayer(p1);
				p1.setNextPointerOfLayer(pointer);
			}else if(p2 != null){
				while(p2 != null){
					p1 = p2;
					p2 = p1.nextBlock();		
				}
				p1.setNextPointerOfBlock(pointer);
			}
		}
		
	}
	
	public void getWholeSize(){
		PointerToBlockOfStartingLayer p1 = BlockList;
		PointerToBlockOfStartingLayer p2 = p1.nextLayer();
		
		while(p2 != null){
			p1 = p2;
			p2 = p1.nextLayer();
		}
		
		p2 = p1;
		
		while(p1 != null){
			
			while(p2 != null){
				setLayerSize(p2.getBlock());
				p2 = p2.nextBlock();
			}
			
			p1 = p1.beforeLayer();
			p2 = p1;
		}
		
	}
	
	public void setLocation(Block start_block, int x, int y){
		Block block = start_block;
		Block b1;
		
		block.setLocation(x,y);
		
		if((b1 = block.getNeighborBlock(Block.IN,Block.END)) != null){
			setLocation(b1,x+1,y+1);
		}
		
		if((b1 = block.getNeighborBlock(Block.LF,Block.START)) != null){
			setLocation(b1,x+block.getArWidth(),y);
		}
		
		if((b1 = block.getNeighborBlock(Block.OV,Block.START)) != null){
			setLocation(b1,x,y+block.getArHeight());
		}
	}
	
	public void initSizeForDrawing(Graphics2D g2d){
		
		/*
		int x = X;
		int y = Y;
		Block block = StartBlock; 
		
		setLocation(StartBlock,X,Y);
		*/
		
		for(int i=0; i<MAX; i++){
			BLOCKWIDTH[i]  = 0;
			BLOCKHEIGHT[i] = 0;
		}
		
		initMaXSizeSeter(StartBlock,g2d);
		
	}
	
	public void initMaXSizeSeter(Block start_block, Graphics2D g2d){
		
		Block block = start_block;
		Block b1;
		
		int x = start_block.getXLocation();
		int y = start_block.getYLocation();
		
		
		System.out.println("x:"+x+","+"y:"+y);/////////////
		
		BLOCKWIDTH[x]  = Math.max(BLOCKWIDTH[x] , block.getWidth(g2d));
		BLOCKHEIGHT[y] = Math.max(BLOCKHEIGHT[y], block.getHeight(g2d));
		
		if((b1 = block.getNeighborBlock(Block.IN,Block.END)) != null){
			initMaXSizeSeter(b1,g2d);
		}
		
		if((b1 = block.getNeighborBlock(Block.LF,Block.START)) != null){
			initMaXSizeSeter(b1,g2d);
		}
		
		if((b1 = block.getNeighborBlock(Block.OV,Block.START)) != null){
			initMaXSizeSeter(b1,g2d);
		}
	}
        
        //add 2003/01/05 Max width of a form graph
        public int getMaxWidth(Block start_block){
            int Width = 0;
            for(int i=1; i<=start_block.getArWidth(); i++){
                Width += BLOCKWIDTH[i];
            }
            return Width;
        }
        
         //add 2003/01/05 Max Height of a form graph
        public int getMaxHeight(Block start_block){
            int Height = 0;
            for(int i=1; i<=start_block.getArHeight(); i++){
                Height += BLOCKHEIGHT[i];
            }
            return Height;
        }
}