/* 
	BackgroundLayer.java

	Author: Tomokazu ARITA
	UpDate: 2001/03/07
	Last Update: 2001/12/06
	Since:  2001/03/07
*/

package hiformed.editor.table;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.awt.RenderingHints;



public class BackgroundLayer extends Layer{
	
	//Graphics (Buffer)
	private BufferedImage buf;
	private Graphics2D bufg2d;
	
	//obt@̔wiF
	private Color buf_bg_color = Color.white;

	public BackgroundLayer(){
		super();
	}
	
		//Graphics̏, obt@̍쐬
	private void initGraphics(){
		Dimension dim = getSize();
		
		buf = (BufferedImage)createImage(dim.width, dim.height);
		bufg2d = (Graphics2D)buf.getGraphics();
		
		bufg2d.setColor(buf_bg_color);
		bufg2d.fillRect(0, 0, dim.width, dim.height);
		
		RenderingHints qualityHints = 
				new RenderingHints(RenderingHints.KEY_ANTIALIASING,
					RenderingHints.VALUE_ANTIALIAS_ON);

		qualityHints.put(RenderingHints.KEY_RENDERING,
						RenderingHints.VALUE_RENDER_QUALITY);

		bufg2d.setRenderingHints(qualityHints);
	}

		
	//C[̕`ig͂̕I[o[Chďj
	protected void drawLayer(Graphics2D g2){
		
		if(buf == null){
			initGraphics();
		}
		
		if(buf != null){
			g2.drawImage(buf,0,0,this);
		}
	}
	
	//obt@̃NA
	public void clear(){
		buf = null;
	}
	
	//obt@`pGraphicsԂ
	public Graphics2D getBufferGraphics(){
		return bufg2d;
	}
	
}
