/* 
	ContentsLayer.java

	Author: Tomokazu ARITA
	UpDate: 2001/03/08
	Last Update: 2001/12/06
	Since:  2001/03/08
*/

package hiformed.editor.table;

import javax.swing.event.CaretListener;
import javax.swing.event.CaretEvent;
import javax.swing.text.Caret;

import java.awt.event.FocusListener;
import java.awt.event.FocusEvent;

import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
//import java.awt.event.MouseAdapter;

import java.awt.Graphics2D;

import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.JTextPane;
import javax.swing.text.JTextComponent;

import java.awt.Point;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Color;

import java.util.Vector;

public class ContentsLayer extends Layer implements CaretListener, FocusListener, MouseListener{

	private Vector cells = new Vector();
	private Layer base_layer = null;
	
	private JTextComponent now_jtc = null;
	private JTextPane dummy_tc = new JTextPane();//
	
	
	public ContentsLayer(Layer base_layer){
		super();
		this.base_layer = base_layer;
		
		addMouseListener(this);
		
		//addFocusListener(this);
		
		dummy_tc.addFocusListener(this);//
		add(dummy_tc);//
		
		super.antialias_onoff = false;
		
	}
	
	public void mousePressed(MouseEvent e){
		if(now_jtc != null){
			now_jtc.setBackground(new Color(0,0,0,0));
			
			Caret caret = now_jtc.getCaret();
			caret.setVisible(false);
			
			Point p = now_jtc.getLocation();
			Dimension d = now_jtc.getSize();
			base_layer.repaint(p.x, p.y, d.width, d.height);
			dummy_tc.requestFocus();
			//requestFocus();
		}
	}
	
	public void mouseClicked(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}
	public void mouseReleased(MouseEvent e){}
	public void mouseExited(MouseEvent e){}
	
	
	
	//LbgɊւCxgLb`
	public void caretUpdate(CaretEvent e){
		JTextComponent jtc = (JTextComponent)e.getSource();
		now_jtc = jtc;
		
		Caret caret = now_jtc.getCaret();
		caret.setVisible(true);
		
		jtc.setBackground(Color.white);
		
		//JTextPane text_pane = (JTextPane)e.getSource();
		//Point p = text_pane.getLocation();
		//Dimension d = text_pane.getSize();
		//base_layer.repaint(p.x, p.y, d.width, d.height);
	}
	
	public void focusGained(FocusEvent e){
		JTextComponent jtc = (JTextComponent)e.getSource();
		jtc.setBackground(Color.white);
		
		Point p = jtc.getLocation();
		Dimension d = jtc.getSize();
		base_layer.repaint(p.x, p.y, d.width, d.height);
	}
	
	public void focusLost(FocusEvent e){
		JTextComponent jtc = (JTextComponent)e.getSource();
		jtc.setBackground(new Color(0,0,0,0));
		
		Point p = jtc.getLocation();
		Dimension d = jtc.getSize();
		base_layer.repaint(p.x, p.y, d.width, d.height);
	}
	
	
	//C[̕`ig͂̕I[o[Chďj
	protected void drawLayer(Graphics2D g){
		//drawCellContents(g);
	}
	
	/*
	//Rec`
	private void drawCellContents(Graphics2D g){
		for(int i=0; i<cells.size(); i++){
			Cell cell   = (Cell)cells.elementAt(i);
			
			if(cell.getTitleOnOff() == cell.ON){drawCellTitle(cell);}//title
		}
	}
	*/
	
	// draw a cell's title.
	public void drawCellTitle(Cell cell){
		DefaultStyledDocument dsd = new DefaultStyledDocument();
		JTextPane text_pane = new JTextPane(dsd);
		text_pane = new JTextPane(dsd);
		
		Point point   = cell.getBasePoint();
		Dimension dim = cell.getCellSize();
		String title  = cell.getTitle();
		Insets side_margin = cell.getSideMargin();
		point = new Point(point.x+side_margin.left, point.y+side_margin.top);
		dim   = new Dimension(
						dim.width-(side_margin.left+side_margin.right), 
						dim.height-(side_margin.top+side_margin.bottom)
					);
		
		text_pane.setLocation(point);
		text_pane.setSize(dim);
		text_pane.setBackground(new Color(0,0,0,0));//
		
		
		try{
			SimpleAttributeSet attr = new SimpleAttributeSet();
			StyleConstants.setFontFamily(attr, "Times New Roman");//test
			StyleConstants.setFontSize(attr, 18);
			
			//StyleConstants.setFontSize(attr, 32);
			//StyleConstants.setForeground(attr, Color.red);
			
			dsd.insertString(0,title, attr);
		}catch(Exception e){}
		
		text_pane.setCaretPosition(0);//caret
		add(text_pane);
		text_pane.addCaretListener(this);//!!!!!!!!!!!!!!!
		text_pane.addFocusListener(this);
	}
	
	/*
	//Z̒ǉ
	public void setCell(Cell cell){
		cells.addElement(cell);
	}
	*/
	
	//C[̃NA
	public void clearLayer(){
		removeAll();//o^ĂZ̍폜
		//repaint();//ĕ`
	}
	
	
}
