/*
 * FormConstructer.java
 *
 * Created on 2001/11/10, 21:44
 * update : 2001/11/30 
 * Last update: 2001/12/08
 */

package hiformed.editor.table;

/*
 * Tomokazu ARITA
 * ver. 0.01a
 */

//jdk 1.3.*
import java.util.Vector;

//hiform
import hiformed.grammar.DTBlock;
import hiformed.grammar.DTNode;

public class FormConstructer extends Object {
	
	private static int shift=10;//\ۂ̃}[Wij
	
	private Vector group = new Vector();
	private Vector cells  = new Vector();
	private Cell form = null;
	
	private DTBlock derivation_tree;
	
    /** Creates new FormConstructer */
    public FormConstructer(DTBlock derivation_tree) {
        this.derivation_tree = derivation_tree;
    }
    
    /* construct form */
    public void construct(){
		getItems(derivation_tree.getStartNode());
    }
    
	//add an item in vector;
    protected void addFormItems(DTNode node, Vector vector){
		Cell cell = chengeToCell(node);
		vector.addElement(cell);
    }
    
	//change a node of a derivation tree to a cell
	private Cell chengeToCell(DTNode node){
		
		//eXgp
		String title = node.getNodeLabel();
		//eXgpI
		
		Cell cell = new Cell(title);
		cell.setBasePoint(node.getAttX()+shift, node.getAttY()+shift);//
		cell.setCellSize(node.getAttWidth(), node.getAttHeight());
		
		//eXgp
		cell.setSideMargin(2,2,2,2);
		cell.setFrameLineSize(1);
		cell.setCellBGColor(new java.awt.Color(0,74,128,50));
		cell.setFrameOnOff(cell.ON);
		cell.setCellBGColorOnOff(cell.ON);
		//eXgpI
		
		return cell;
	}
	
	// main
	private void getItems(DTNode node){
		if(node==null){return;}
		
		DTBlock children;
		if((children = node.getNextBlock()) != null){
			DTNode child = children.getStartNode();
			while(child != null){
				if(child.getNextBlock() != null){
					getItems(child);
				}else{
					checkItem(child);
				}
				child = child.getNextNode();
			}
		}
	}
	
	private void checkItem(DTNode node){
		
		String label = node.getNodeLabel();
		if(label.equals("FORM")){
			form = chengeToCell(node);
		}else if(label.equals("HEAD") || label.equals("A1")){
			addFormItems(node, group);
		}else{
			addFormItems(node, cells);
		}
	}
	
	public Vector getCells(){
		return cells;
	}
}
