/*
 * TablePanel.java
 *
 * Created on 2001/12/08, 20:45
 */

package hiformed.editor.table;

/**
 *
 * Tomokazu Arita
 * 0.01a
 */

//jdk 1.3.*
import javax.swing.JPanel;
import java.awt.Dimension;

//hiformed
import hiformed.grammar.DTBlock;

public class TablePanel extends JPanel {

	private LayerManager lm = new LayerManager();
	private FormConstructer fc = null;
	private FormDrawer fd = null;
	
	private DTBlock derivation_tree = null;
	
	/** Creates new TablePanel */
    public TablePanel(){
		initPanel();
    }
	
	//
	private void initPanel(){
		add(lm.getLayers());
	}
	
	//tH[RXgN^[ZbgD
	public void setFormConstructer(FormConstructer fc){
		this.fc = fc;
		this.fd = new FormDrawer(fc, lm);
	}
	
	//`
	public void drawCells(){
		if(derivation_tree != null){
			FormConstructer fc = new FormConstructer(derivation_tree);
			setFormConstructer(fc);
			fd.drawCells();
		}
	}
	
	//Dtree Zbg
	public void setDerivationTree(DTBlock derivation_tree){
		this.derivation_tree = derivation_tree;
	}
	
	/*
	//size ݒ
	public Dimension getPreferredSize(){
		return new Dimension(300, 1000);
	}
	
	public Dimension getMinimumSize(){
		return getPreferredSize();
	}
	*/

}
