/* 
	MGNode.java

	Author:			Tomokazu ARITA
	Description:	2001/11/27
	update: 2002/01/14
*/

package hiformed.grammar;

public class MGNode{
	
	//Handlep
	public static final int START = 1;
	public static final int END   = 2;

		
	//ϐ
	private int node_label = -1;
	private int node_id = -1; //productionŎgp
	private String node_name = ""; // 2001/1/14ǉ@CX^XŎgp閼O
	private int att_x = -1;
	private int att_y = -1;
	private int att_width  = -1;
	private int att_height = -1;
	
	//אڕӂ̐ݒ
	private MGNode in_start = null;
	private MGNode in_end   = null;
	private MGNode ov_start = null;
	private MGNode ov_end   = null;
	private MGNode lf_start = null;
	private MGNode lf_end   = null;
	
	/*
	//ӂɑ΂鏇
	private int in_start_precedence = -1;
	private int in_end_precedence   = -1;
	private int ov_start_precedence = -1;
	private int ov_end_precedence   = -1;
	private int lf_start_precedence = -1;
	private int lf_end_precedence   = -1;
	*/
	
	//HandleT̎ɂ̒_ǂptO
	private boolean flag_this_node_was_checked = false;
	
	//Handleł邩ǂ
	private boolean flag_this_node_is_handle = false;
	
	//HandleT̎ɂ̕ӂǂptO
	private boolean flag_instart_edge_was_checked = false;
	private boolean flag_inend_edge_was_checked = false;
	private boolean flag_ovstart_edge_was_checked = false;
	private boolean flag_ovend_edge_was_checked = false;
	private boolean flag_lfstart_edge_was_checked = false;
	private boolean flag_lfend_edge_was_checked = false;
	
	//RXgN^
	public MGNode(){
	}

//--------------------------------------------------------------
//	[  _ID֌W ]
//--------------------------------------------------------------
	public void setNodeID(int id){
		this.node_id = id;
	}
	
	public int getNodeID(){
		return node_id;
	}

//--------------------------------------------------------------

//--------------------------------------------------------------
//	[  _̐ݒp\bh ]
//--------------------------------------------------------------
//אڒ_ւ̃|C^̐ݒs

	public void setInStartNode(MGNode node){
		this.in_start = node;
	}
	
	public void setInEndNode(MGNode node){
		this.in_end = node;
	}
	
	public void setOvStartNode(MGNode node){
		this.ov_start = node;
	}
	
	public void setOvEndNode(MGNode node){
		this.ov_end = node;
	}
	
	public void setLfStartNode(MGNode node){
		this.lf_start = node;
	}
	
	public void setLfEndNode(MGNode node){
		this.lf_end = node;
	}

//--------------------------------------------------------------

/*
//--------------------------------------------------------------
//	[  ʂ̐ݒp\bh ]
//--------------------------------------------------------------
//ʂ̐ݒs
	
	public void setInStartPrecedence(int precedence){
		this.in_start_precedence = precedence;
	}
	
	public void setInEndPrecedence(int precedence){
		this.in_end_precedence = precedence;
	}
	
	public void setOvStartPrecedence(int precedence){
		this.ov_start_precedence = precedence;
	}
	
	public void setOvEndPrecedence(int precedence){
		this.ov_end_precedence = precedence;
	}
	
	public void setLfStartPrecedence(int precedence){
		this.lf_start_precedence = precedence;
	}
	
	public void setLfEndPrecedence(int precedence){
		this.lf_end_precedence = precedence;
	}
	
//--------------------------------------------------------------
*/

//--------------------------------------------------------------
//	[  _Ԃ\bh ]
//--------------------------------------------------------------
//אڒ_ւ̃|C^Ԃ

	public MGNode getInStartNode(){
		return in_start;
	}
	
	public MGNode getInEndNode(){
		return in_end;
	}
	
	public MGNode getOvStartNode(){
		return ov_start;
	}
	
	public MGNode getOvEndNode(){
		return ov_end;
	}

	public MGNode getLfStartNode(){
		return lf_start;
	}
	
	public MGNode getLfEndNode(){
		return lf_end;
	}

//--------------------------------------------------------------

/*
//--------------------------------------------------------------
//	[  ʂ̕Ԃ\bh ]
//--------------------------------------------------------------
//ʂԂ

	public int getInStartPrecedence(){
		return in_start_precedence;
	}
	
	public int getInEndPrecedence(){
		return in_end_precedence;
	}
	
	public int getOvStartPrecedence(){
		return ov_start_precedence;
	}
	
	public int getOvEndPrecedence(){
		return ov_end_precedence;
	}

	public int getLfStartPrecedence(){
		return lf_start_precedence;
	}
	
	public int getLfEndPrecedence(){
		return lf_end_precedence;
	}


//--------------------------------------------------------------
*/

//--------------------------------------------------------------
//	[  xɊւ郁\bh ]
//--------------------------------------------------------------

	public void setNodeLabel(int label){
		this.node_label = label;
	}
	
	public int getNodeLabel(){
		return node_label;
	}

//--------------------------------------------------------------

//--------------------------------------------------------------
//	[  Ɋւ郁\bh ]
//--------------------------------------------------------------

	public void setAttX(int x){
		this.att_x = x;
	}
	
	public int getAttX(){
		return att_x;
	}

	public void setAttY(int y){
		this.att_y = y;
	}
	
	public int getAttY(){
		return att_y;
	}
	
	public void setAttWidth(int width){
		this.att_width = width;
	}
	
	public int getAttWidth(){
		return att_width;
	}
	
	public void setAttHeight(int height){
		this.att_height = height;
	}
		
	public int getAttHeight(){
		return att_height;
	}


//--------------------------------------------------------------

//--------------------------------------------------------------
//	[  nh̃tO ]
//--------------------------------------------------------------

	public void checkEdge(int edge_label, int start_or_end){
		
		
		if(edge_label == MGEdgeLabelSet.IN){
			
			if(start_or_end == MGNode.START){
				flag_instart_edge_was_checked = true;
			}else if(start_or_end == MGNode.END){
				flag_inend_edge_was_checked = true;
			}
		}else if(edge_label == MGEdgeLabelSet.OV){
			
			if(start_or_end == MGNode.START){
				flag_ovstart_edge_was_checked = true;
			}else if(start_or_end == MGNode.END){
				flag_ovend_edge_was_checked = true;
			}
		}else if(edge_label == MGEdgeLabelSet.LF){
			
			if(start_or_end == MGNode.START){
				flag_lfstart_edge_was_checked = true;
			}else if(start_or_end == MGNode.END){
				flag_lfend_edge_was_checked = true;
			}
		}
		
		
	}
	
	public void checkNode(){
		flag_this_node_was_checked = true;
	}
	
	public void checkThisIsHandleNode(){
		flag_this_node_is_handle = true;
	}
	
	public boolean getNodeFlag(){
		return flag_this_node_was_checked;
	}
	
	public boolean getEdgeFlag(int edge_label, int start_or_end){
		
		if(edge_label == MGEdgeLabelSet.IN){
			
			if(start_or_end == MGNode.START){
				return flag_instart_edge_was_checked;
			}else if(start_or_end == MGNode.END){
				return flag_inend_edge_was_checked;
			}
		}else if(edge_label == MGEdgeLabelSet.OV){
			
			if(start_or_end == MGNode.START){
				return flag_ovstart_edge_was_checked;
			}else if(start_or_end == MGNode.END){
				return flag_ovend_edge_was_checked;
			}
		}else if(edge_label == MGEdgeLabelSet.LF){
			
			if(start_or_end == MGNode.START){
				return flag_lfstart_edge_was_checked;
			}else if(start_or_end == MGNode.END){
				return flag_lfend_edge_was_checked;
			}
		}
		
		return false;
		
	}
	
	
	public void initFlags(){
		flag_this_node_was_checked = false;
		//flag_this_node_is_handle = false;
		
		flag_instart_edge_was_checked = false;
		flag_inend_edge_was_checked = false;
		flag_ovstart_edge_was_checked = false;
		flag_ovend_edge_was_checked = false;
		flag_lfstart_edge_was_checked = false;
		flag_lfend_edge_was_checked = false;
		
		if(in_end != null){ getInEndNode().initFlags(); }
		if(ov_start != null){ getOvStartNode().initFlags(); }
		if(lf_start != null){ getLfStartNode().initFlags(); }
	}



//--------------------------------------------------------------

	
//--------------------------------------------------------------
//	[  _̖O ] 2002/1/14 VKǉ@CX^XŎgp
//--------------------------------------------------------------
	public void setNodeName(String name){
		this.node_name = name;
	}
	
	public String getNodeName(){
		return node_name;
	}
//--------------------------------------------------------------
	
}
