/* 
	Production.java

	Author:			Tomokazu ARITA
	update:			2001/11/27	
*/

package hiformed.grammar;

public class Production{
	
	private String production_name = "";
	
	private Production next = null;
	
	private MGNode left_hand_side  = null;
	
	private MarkedGraph right_hand_side = null;
	private ConnectionRelation connecton_relation = null; 
	
	private SemanticRule semantic_rule = null;
	
	/*
	private int edge_in_start  = -1;
	private int edge_in_end    = -1;
	private int edge_ov_start  = -1;
	private int edge_ov_end    = -1;
	private int edge_lf_start  = -1;
	private int edge_lf_end    = -1;
	*/
	
	public Production(){
	}
	
	public void setNext(Production next){
		this.next = next;
	}
	
	public Production getNext(){
		return next;
	}
	
	public MGNode getLeftHandSide(){
		return left_hand_side;
	}
	
	public void setLeftHandSide(MGNode node){
		left_hand_side = node;
	}
	
	public MarkedGraph getRightHandSide(){
		return right_hand_side;
	}
	
	public void setRightHandSide(MarkedGraph graph){
		right_hand_side = graph;
	}
	
	public void addCR(ConnectionRelation cr){
		cr.setNext(connecton_relation);
		connecton_relation = cr;
	}
	
	public ConnectionRelation getCR(){
		return connecton_relation;
	}
	
	public void setProductionName(String name){
		this.production_name = name;
	}
	
	public String getProductionName(){
		return production_name;
	}
	
	public void setSemanticRule(SemanticRule semantic_rule){
		this.semantic_rule = semantic_rule;
	}
	
	public SemanticRule getSemanticRule(){
		return semantic_rule;
	}

}
