/* 
	MGraphA1.java

	Author:			Tomokazu ARITA
	update:			2001/11/28
*/

package hiformed.hngg.Graphs;

import hiformed.grammar.*;
import hiformed.hngg.NodeSet.*;

public class MGraphA1 extends MarkedGraph{
	
	public static final int FORM_WIDTH   = 400;
	public static final int CELL_WIDTH   = FORM_WIDTH/2;
	public static final int CELL_HEIGHT  = 30;
	
	public MGraphA1(){
		
		//MGNode node1 = new MGNode();  node1.setNodeLabel(NodeSetA1.FORM); node1.setAttX(0); node1.setAttY(0);
		//MGNode node2 = new MGNode();  node2.setNodeLabel(NodeSetA1.HEAD);
		//MGNode node3 = new MGNode();  node3.setNodeLabel(NodeSetA1.HEAD_ROOT);
		
		
		MGNode node1 = new MGNode();  node1.setNodeLabel(NodeSetA1.FORM); node1.setAttX(0); node1.setAttY(0);
		
		MGNode node2 = new MGNode();  node2.setNodeLabel(NodeSetA1.HEAD_GROUP);// node2.setAttX(0); node2.setAttY(0);
		MGNode node3 = new MGNode();  node3.setNodeLabel(NodeSetA1.PROGRAM_NAME); node3.setAttWidth(FORM_WIDTH);  node3.setAttHeight(CELL_HEIGHT);
		MGNode node4 = new MGNode();  node4.setNodeLabel(NodeSetA1.SUBTITLE);     node4.setAttWidth(FORM_WIDTH);  node4.setAttHeight(CELL_HEIGHT);
		MGNode node5 = new MGNode();  node5.setNodeLabel(NodeSetA1.LIBRARY_CODE); node5.setAttWidth(CELL_WIDTH);  node5.setAttHeight(CELL_HEIGHT);
		MGNode node6 = new MGNode();  node6.setNodeLabel(NodeSetA1.VERSION);      node6.setAttWidth(CELL_WIDTH);  node6.setAttHeight(CELL_HEIGHT);
		MGNode node7 = new MGNode();  node7.setNodeLabel(NodeSetA1.AUTHOR);       node7.setAttWidth(CELL_WIDTH);  node7.setAttHeight(CELL_HEIGHT);
		MGNode node8 = new MGNode();  node8.setNodeLabel(NodeSetA1.APPROVER);     node8.setAttWidth(CELL_WIDTH);  node8.setAttHeight(CELL_HEIGHT);
		MGNode node9 = new MGNode();  node9.setNodeLabel(NodeSetA1.ORIGINAL_RELEASE); node9.setAttWidth(CELL_WIDTH);  node9.setAttHeight(CELL_HEIGHT);
		MGNode node10 = new MGNode(); node10.setNodeLabel(NodeSetA1.CORRENT_RELEASE); node10.setAttWidth(CELL_WIDTH);  node10.setAttHeight(CELL_HEIGHT);
		
		//MGNode node11 = new MGNode(); node11.setNodeLabel(NodeSetA1.BODY);//test
		MGNode node11 = new MGNode(); node11.setNodeLabel(NodeSetA1.A1_GROUP);
		MGNode node12 = new MGNode(); node12.setNodeLabel(NodeSetA1.KEY_WORDS); node12.setAttWidth(CELL_WIDTH);  node12.setAttHeight(CELL_HEIGHT);
		MGNode node13 = new MGNode(); node13.setNodeLabel(NodeSetA1.CR_CODE);   node13.setAttWidth(CELL_WIDTH);  node13.setAttHeight(CELL_HEIGHT);
		MGNode node14 = new MGNode(); node14.setNodeLabel(NodeSetA1.SCOPE);     node14.setAttWidth(FORM_WIDTH);  node14.setAttHeight(CELL_HEIGHT);
		MGNode node15 = new MGNode(); node15.setNodeLabel(NodeSetA1.VARIANT);   node15.setAttWidth(FORM_WIDTH);  node15.setAttHeight(CELL_HEIGHT);
		MGNode node16 = new MGNode(); node16.setNodeLabel(NodeSetA1.LANGUAGE);  node16.setAttWidth(CELL_WIDTH);  node16.setAttHeight(CELL_HEIGHT);
		MGNode node17 = new MGNode(); node17.setNodeLabel(NodeSetA1.OPERATION); node17.setAttWidth(CELL_WIDTH);  node17.setAttHeight(CELL_HEIGHT);
		MGNode node18 = new MGNode(); node18.setNodeLabel(NodeSetA1.SOFTWARE_REQUIRE); node18.setAttWidth(CELL_WIDTH);  node18.setAttHeight(CELL_HEIGHT);
		MGNode node19 = new MGNode(); node19.setNodeLabel(NodeSetA1.HARDWARE_REQUIRE); node19.setAttWidth(CELL_WIDTH);  node19.setAttHeight(CELL_HEIGHT);
		MGNode node20 = new MGNode(); node20.setNodeLabel(NodeSetA1.REFERENCES); node20.setAttWidth(FORM_WIDTH);  node20.setAttHeight(CELL_HEIGHT);
		
		MGNode node21 = new MGNode(); node21.setNodeLabel(NodeSetA1.FUNCTION); node21.setAttWidth(FORM_WIDTH);  node21.setAttHeight(CELL_HEIGHT*8);
		MGNode node22 = new MGNode(); node22.setNodeLabel(NodeSetA1.EXAMPLE); node22.setAttWidth(FORM_WIDTH);  node22.setAttHeight(CELL_HEIGHT*8);
		
		
		//edge
		
		//node1.setInEndNode(node2); node2.setInStartNode(node1);//
		//node2.setOvStartNode(node3); node3.setOvEndNode(node2);//
		
		
		//node1.setOvStartNode(node2); node2.setOvEndNode(node1);//
		
		
		node1.setInEndNode(node2); node2.setInStartNode(node1);
		
		
		node2.setInEndNode(node3); node3.setInStartNode(node2);
		node3.setOvStartNode(node4); node4.setOvEndNode(node3);
		node4.setOvStartNode(node5); node5.setOvEndNode(node4);
		node5.setOvStartNode(node7); node7.setOvEndNode(node5);
		node7.setOvStartNode(node8); node8.setOvEndNode(node7);
		
		node5.setLfStartNode(node6);  node6.setLfEndNode(node5);
		node7.setLfStartNode(node9);  node9.setLfEndNode(node7);
		node8.setLfStartNode(node10); node10.setLfEndNode(node8);
		
		
		node2.setOvStartNode(node11); node11.setOvEndNode(node2);
		
		
		node11.setInEndNode(node12); node12.setInStartNode(node11);
		
		node12.setOvStartNode(node14); node14.setOvEndNode(node12);
		node14.setOvStartNode(node15); node15.setOvEndNode(node14);
		node15.setOvStartNode(node16); node16.setOvEndNode(node15);
		node16.setOvStartNode(node17); node17.setOvEndNode(node16);
		node17.setOvStartNode(node20); node20.setOvEndNode(node17);
		node20.setOvStartNode(node21); node21.setOvEndNode(node20);
		node21.setOvStartNode(node22); node22.setOvEndNode(node21);
		
		node12.setLfStartNode(node13); node13.setLfEndNode(node12);
		node16.setLfStartNode(node18); node18.setLfEndNode(node16);
		node17.setLfStartNode(node19); node19.setLfEndNode(node17);
		
		
		setStartNode(node1);//
	}

}
