/* 
	NodeSetA1.java

	Author:			Tomokazu ARITA
	update:			2001/11/28
*/

package hiformed.hngg.NodeSet;

import hiformed.grammar.*;


public class NodeSetA1 extends MGNodeMarkSet{
	
	//HEAD NODE
	public static final int STRUCT = 0;//START_NODE
	public static final int FORM = 1;
	public static final int INNER_STRUCT = 2;
	public static final int HEAD = 3;
	public static final int BODY = 4;
	
	public static final int HEAD_GROUP  = 5;
	public static final int HEAD_ROOT   = 6;
	public static final int HEAD_ROW    = 7;
	public static final int HEAD_COLUMN = 8;
	public static final int HEAD_SCALAR = 9;
	
	public static final int PROGRAM_NAME = 10;
	public static final int SUBTITLE     = 11;
	public static final int LIBRARY_CODE = 12;
	public static final int VERSION      = 13;
	public static final int AUTHOR       = 14;
	public static final int APPROVER     = 15;
	public static final int ORIGINAL_RELEASE = 16;
	public static final int CORRENT_RELEASE  = 17;
	
	
	//A1 NODE
	public static final int A1        = 18;
	public static final int A1_GROUP  = 19;
	public static final int A1_ROOT   = 20;
	public static final int A1_ROW    = 21;
	public static final int A1_COLUMN = 22;
	public static final int A1_SCALAR = 23;
	
	
	public static final int KEY_WORDS = 24;
	public static final int CR_CODE   = 25;
	public static final int SCOPE     = 26;
	public static final int VARIANT   = 27;
	public static final int LANGUAGE  = 28;
	public static final int OPERATION = 29;
	public static final int SOFTWARE_REQUIRE = 30;
	public static final int HARDWARE_REQUIRE = 31;
	public static final int REFERENCES = 32;
	public static final int FUNCTION   = 33;
	public static final int EXAMPLE    = 34;
	
	
	
	public static final String[]  NODE_LABEL = {
		"[ struct ]",
		"FORM",
		"[ innerstruct ]",
		"[ head ]",
		"[ body ]",
		
		"HEAD",
		"[ head root ]",
		"[ head row ]",
		"[ head column ]",
		"[ head scalar ]",
		
		"Program Name",
		"Subtitle",
		"Library Code",
		"Version",
		"Author",
		"Approver",
		"Original Release",
		"Corrent Release",
		
		"[ a1 ]",
		"A1",
		"[ a1 root ]",
		"[ a1 row ]",
		"[ a1 column ]",
		"[ a1 scalar ]",
		
		"Key Words",
		"CR Code",
		"Scope",
		"Variants",
		"Language",
		"Operation",
		"Software Req.",
		"Headware Req.",
		"References",
		"Function",
		"Example"
		
	};
	
	public NodeSetA1(){
	}
	
	public String getNodeMark(int label){
		if(label >= 0){
			return NODE_LABEL[label];
		}
		return "";
	}
	
	public int getStartNodeLabel(){
		return STRUCT;
		//return HEAD;
	}
	
	public String getNodeString(int node_id){
		return NODE_LABEL[node_id];
	}
}