/* 
	A1_0.java

	Author:			Tomokazu ARITA
	update:			2001/11/28
*/


package hiformed.hngg.Productions;

import hiformed.grammar.*;
import hiformed.hngg.NodeSet.*;
import hiformed.hngg.SemanticRules.*;


public class A1_0 extends Production{

	public A1_0(){
		//Production name
		setProductionName("A1-0");
		
		// Left Hand Side
		MGNode left = new MGNode();
		left.setNodeLabel(NodeSetA1.BODY);
		left.setNodeID(0);
		setLeftHandSide(left);
		
		//Right Hand Side
		MGNode node1 = new MGNode();
		node1.setNodeLabel(NodeSetA1.A1);
		node1.setNodeID(1);
		
		
		MarkedGraph right = new MarkedGraph();
		right.setStartNode(node1);
		setRightHandSide(right);
		
		//Connection Relation
		ConnectionRelation cr1 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.IN,
										MGEdgeLabelSet.IN,
										node1.getNodeID(),
										ConnectionRelation.OUT
									  );
		
		ConnectionRelation cr2 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.OV,
										MGEdgeLabelSet.OV,
										node1.getNodeID(),
										ConnectionRelation.IN
									  );
		
		addCR(cr1);
		addCR(cr2);
		
		//Semantic Rule
		setSemanticRule(new SA1_0());
	}
	

}