/* 
	A1_2.java

	Author:			Tomokazu ARITA
	update:			2001/11/28
*/


package hiformed.hngg.Productions;

import hiformed.grammar.*;
import hiformed.hngg.NodeSet.*;
import hiformed.hngg.SemanticRules.*;

public class A1_2 extends Production{

	public A1_2(){
		//Production name
		setProductionName("A1-2");
		
		// Left Hand Side
		MGNode left = new MGNode();
		left.setNodeLabel(NodeSetA1.A1_ROOT);
		left.setNodeID(0);
		setLeftHandSide(left);
		
		//Right Hand Side
		MGNode node1 = new MGNode();
		node1.setNodeLabel(NodeSetA1.A1_ROW);
		node1.setNodeID(1);
		
		MGNode node2 = new MGNode();
		node2.setNodeLabel(NodeSetA1.A1_ROOT);
		node2.setNodeID(2);
		
		node1.setOvStartNode(node2);
		node2.setOvEndNode(node1);
		
		MarkedGraph right = new MarkedGraph();
		right.setStartNode(node1);
		setRightHandSide(right);
		
		//Connection Relation
		ConnectionRelation cr1 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.IN,
										MGEdgeLabelSet.IN,
										node1.getNodeID(),
										ConnectionRelation.OUT
									  );
		
		ConnectionRelation cr2 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.OV,
										MGEdgeLabelSet.OV,
										node1.getNodeID(),
										ConnectionRelation.IN
									  );
		
		addCR(cr1);
		addCR(cr2);
		
		//Semantic Rule
		setSemanticRule(new SA1_2());
	}
	

}