/* 
	P2.java

	Author:			Tomokazu ARITA
	update:			2001/11/28
*/


package hiformed.hngg.Productions;

import hiformed.grammar.*;
import hiformed.hngg.NodeSet.*;
import hiformed.hngg.SemanticRules.*;

public class P2 extends Production{

		public P2(){
		//Production name
		setProductionName("2");
		
		// Left Hand Side
		MGNode left = new MGNode();
		left.setNodeLabel(NodeSetA1.INNER_STRUCT);
		left.setNodeID(0);
		setLeftHandSide(left);
		
		//Right Hand Side
		MGNode node1 = new MGNode();
		node1.setNodeLabel(NodeSetA1.HEAD);
		node1.setNodeID(1);
		
		MGNode node2 = new MGNode();
		node2.setNodeLabel(NodeSetA1.BODY);
		node2.setNodeID(2);
		
		node1.setOvStartNode(node2);
		node2.setOvEndNode(node1);
		
		MarkedGraph right = new MarkedGraph();
		right.setStartNode(node1);
		setRightHandSide(right);
		
		//Connection Relation
		ConnectionRelation cr1 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.IN,
										MGEdgeLabelSet.IN,
										node1.getNodeID(),
										ConnectionRelation.OUT
									  );
		
		
		addCR(cr1);
		
		//Semantic Rule
		setSemanticRule(new SP2());
	}
	

}